'Journal to Cycle All Attributes in a Part

Imports NXOpen
Imports NXOpenUI
Imports NXOpen.uf
 
Module Cycle_Part_Attributes
    Dim theSession As Session = Session.GetSession
    Dim LW As ListingWindow = theSession.ListingWindow
    Dim theUI As UI = UI.GetUI

    Dim workPart As Part = theSession.Parts.Work

    Sub Main()
        Try
            LW.Open()
            LW.WriteLine("Cycle Part Attributes")

            LW.WriteLine("Work Part Path: " & workPart.FullPath)
            LW.WriteLine("Work Part Name: " & workPart.Leaf)
            LW.WriteLine("Start Time: " & CType(TimeOfDay(), String))

            Dim nAttributes As Integer = 0

            Dim attributeTitles() As NXObject.AttributeInformation

            attributeTitles = workPart.GetAttributeTitlesByType( _
                                NXObject.AttributeType.String)

            LW.WriteLine("*** STRING ATTRIBUTES ***")
            For Each info As NXObject.AttributeInformation In attributeTitles
                Dim value = workPart.GetStringAttribute(info.Title)
                LW.WriteLine(info.Title & " = " & value)
                nAttributes = nAttributes + 1
            Next

            attributeTitles = workPart.GetAttributeTitlesByType( _
                                NXObject.AttributeType.Integer)

            LW.WriteLine("*** INTEGER ATTRIBUTES ***")
            For Each info As NXObject.AttributeInformation In attributeTitles
                Dim value = workPart.GetIntegerAttribute(info.Title)
                LW.WriteLine(info.Title & " = " & value.ToString)
                nAttributes = nAttributes + 1
            Next

            attributeTitles = workPart.GetAttributeTitlesByType( _
                                NXObject.AttributeType.Real)

            LW.WriteLine("*** REAL ATTRIBUTES ***")
            For Each info As NXObject.AttributeInformation In attributeTitles
                Dim value = workPart.GetRealAttribute(info.Title)
                LW.WriteLine(info.Title & " = " & value.ToString)
                nAttributes = nAttributes + 1
            Next

            attributeTitles = workPart.GetAttributeTitlesByType( _
                                NXObject.AttributeType.Time)

            LW.WriteLine("*** TIME ATTRIBUTES ***")
            For Each info As NXObject.AttributeInformation In attributeTitles
                Dim dtFormat As NXObject.DateAndTimeFormat = NXObject.DateAndTimeFormat.Textual
                Dim value = workPart.GetTimeAttribute(dtFormat, info.Title)
                LW.WriteLine(info.Title & " = " & value.ToString)
                nAttributes = nAttributes + 1
            Next

            attributeTitles = workPart.GetAttributeTitlesByType( _
                                NXObject.AttributeType.Reference)

            LW.WriteLine("*** REFERENCE ATTRIBUTES ***")
            For Each info As NXObject.AttributeInformation In attributeTitles
                Dim value = workPart.GetReferenceAttribute(info.Title)
                LW.WriteLine(info.Title & " = " & value.ToString)
                nAttributes = nAttributes + 1
            Next

            LW.WriteLine("Number of Attributes: " & nAttributes.ToString)
            LW.WriteLine("Stop Time: " & CType(TimeOfDay(), String))
        Catch ex As NXException
            LW.WriteLine("Cycle Part Attribute Error: " & ex.Message)
        End Try
    End Sub
End Module

